/**
 * Copyright (c) 2008-2011 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://www.sonatype.com/products/nexus/attributions.
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
package org.sonatype.nexus.plugins.aether;

import org.sonatype.aether.RepositoryListener;
import org.sonatype.aether.RepositorySystem;
import org.sonatype.aether.RepositorySystemSession;
import org.sonatype.nexus.plugins.aether.workspace.NexusWorkspace;

/**
 * Aether provider provides prepped embedded Aether for either direct use, or for use by other "higher" level
 * components.
 * 
 * @author cstamas
 */
public interface AetherProvider
{
    RepositorySystem getRepositorySystem();

    RepositorySystemSession getDefaultRepositorySystemSession( RepositorySystem repositorySystem );

    RepositorySystemSession getDefaultRepositorySystemSession( RepositorySystem repositorySystem,
                                                               NexusWorkspace nexusWorkspace, boolean dirtyTree,
                                                               RepositoryListener listener );
}
